
// gcc -g -m64 main.c -o main

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "inttypes.h"

uint64_t R0, R1, R2, R3, R4, R5, R6, R7, R8, R9, R10;

int table_sz = 0;
uint64_t keys[8], vals[8];

uint64_t *map_lookup( uint64_t key ) {
    int i;
    uint64_t *ret = NULL;
    for( i=0; i<table_sz; i++ )
        if( keys[i] == key )
            ret = &vals[i];
    //printf("func_1 lookup failed!\n");
    return ret;
}

uint64_t func_1(uint64_t R1, uint64_t R2, uint64_t R3, uint64_t R4) {
    uint64_t key = *(uint64_t*)R2;
    
    printf("func_1 map_lookup tableid %lu, key %lu\n", R1, key);
    return (uint64_t)map_lookup( key );
/*
    uint64_t *ret = NULL;
    for( i=0; i<table_sz; i++ )
        if( keys[i] == key )
            ret = &vals[i];
    //printf("func_1 lookup failed!\n");
    return (uint64_t)ret;
*/
}

uint64_t func_2(uint64_t R1, uint64_t R2, uint64_t R3, uint64_t R4) {
    int i;
    uint64_t key = *(uint64_t*)R2;
    uint64_t val = *(uint64_t*)R3;
    printf("func_2 map_update tableid %lu, key %lu val %lu flags %lu\n", R1, key, val, R4);

    for( i=0; i<table_sz; i++ )
        if( keys[i] == key ) {
            vals[i] = val;
            return 0;
        }

    if( table_sz >= 8 ) {
        printf("table full!\n");
        exit(-1);
    }
    keys[ table_sz ] = key;
    vals[ table_sz ] = val;
    table_sz ++;
    return 0;
}

uint8_t load_be_uint8_t(uint64_t ptr) {
    return *(uint8_t*)ptr;
}
uint16_t load_be_uint16_t(uint64_t ptr) {
    uint8_t *p = (uint8_t *)ptr;
    return (p[0]<<8) | p[1];
}
uint32_t load_be_uint32_t(uint64_t ptr) {
    uint8_t *p = (uint8_t *)ptr;
    return (p[0]<<24) | (p[1]<<16) | (p[2]<<8) | p[3];
}
uint64_t load_be_uint64_t(uint64_t ptr) {
    uint8_t *p = (uint8_t *)ptr;
    return ((uint64_t)p[0]<<54) | ((uint64_t)p[1]<<48) | ((uint64_t)p[2]<<40) | ((uint64_t)p[3]<<32) | (p[4]<<24) | (p[5]<<16) | (p[6]<<8) | p[7];
}

int f() {
    #include "tt"
}

char packet[1024];

/* BPF program can access up to 512 bytes of stack space. */
char stack[512];

int call_f( const char *packetfile ) {

    printf("----------------------------\n");
    printf("Loading file '%s'\n", packetfile );
    memset( packet, 0, sizeof(packet) );
    int fd = open(packetfile, O_RDONLY );
    read( fd, packet, 1024 );
    close( fd );
    R1 = (uint64_t)packet;    // First arg to f()

    memset( stack, 0, sizeof(stack) );
    R10 = (uint64_t)&(stack[512]);
    f();
    printf("f returned R0=0x%lx\n", R0);

    uint64_t state = *map_lookup( 0 );
    printf("table_val[0] = %lu\n", state );
    if( state == 1) printf("You found a LUM!\n");
    else if( state == 2) printf("You found a KEY!\n");
    else printf("You found nothing\n");
}

int main(int argc, char *argv[]) {
    call_f( "lumpacket.bin" );
    call_f( "keypacket.bin" );
}
