
import sys
sys.path.append( "/challenges/tools")

import ctypes
import fcntl
import tee_client as tc
import struct 
import binascii


def send_message( ta_msg ):
	tee_msg = tc.tee_message()
	tee_msg.cmd = tc.tee_message.CMD_TA_MESSAGE
	tee_msg.data_in_len = len(ta_msg)
	tee_msg.data_in = ctypes.c_char_p(ta_msg)
	tee_msg.data_out_len = 260
	response = '\x00'*tee_msg.data_out_len
	tee_msg.data_out = ctypes.c_char_p(response)

	devicehandle = open('/dev/sstic', 'r')

	try:
		fcntl.ioctl(devicehandle, 0xc0145300, tee_msg)
		#for i in range(100):
		#	sys.stdout.write("0x%02x " % ord(response[i]))
		#print()
		#print(response[4:])
		#response = tee_msg.data_out[4:tee_msg.data_out_len]
	except Exception as e:
		print("got an exception!", repr(e))
		pass
	finally:
		devicehandle.close()
		return response

def load_ta(tabytes):

	tee_msg = tc.tee_message()
	tee_msg.cmd = tc.tee_message.CMD_LOAD_TA
	tee_msg.data_in_len = len(tabytes)
	tee_msg.data_in = ctypes.c_char_p(tabytes)
	tee_msg.data_out_len = tc.tee_message.MAX_LEN
	tee_msg.data_out = ctypes.c_char_p('\x00'*tc.tee_message.MAX_LEN)

	devicehandle = open('/dev/sstic', 'r')
	version = None

	try:
		fcntl.ioctl(devicehandle, 0xc0145300, tee_msg)
		version = tee_msg.data_out[:tee_msg.data_out_len]
	except Exception as e:
		print("got an exception!", repr(e))
		pass
	finally:
		devicehandle.close()
		return version

if len(sys.argv) != 4:
	print("Usage: %s <passwd 32hexstr> <encrypted in file> <decrypted out file>" % sys.argv[0])
	sys.exit(-1)

#passstr = binascii.unhexlify( "00112233445566778899AABBCCDDEEFF" )
passstr = sys.argv[1]
infile = sys.argv[2]
outfile = sys.argv[3]
passwd = binascii.unhexlify( passstr ) 


#ver = tc.get_version()
#print(ver)
ta = open("/challenges/riscy_zones/TA.elf.signed", "rb").read()
ret = load_ta( ta )
print(ret)


print("sending CMD_GET_TA_LUM");
msg = "\x04\x00\x00\x00"
response = send_message( msg )
code, = struct.unpack("<I", response[:4])
print(code, response[4:])


fbytes = open(infile, "rb").read()
xorbytes = fbytes[0x70:0x70+16]
xorbytes = [ ord(c) for c in reversed(fbytes[0x70:0x70+16]) ]

#candidates = open("candidates", "rt").readlines()
cand = 0x00112233445566778899AABBCCDDEEFF
cand = 0x5921cd9fd2ec7bd9244ece538acecbdf	# with default lzma comp level (5)
cand = 0x5129cd9fd2ec7bd9244ece538acecbdf	# with lzma -4 (comp level 4)
cand = 0x5929cd9fd2ec7bd9305ace538acecbdf	# with lzma -2 (comp level 2)
cand = 0x00112233105763778899aabb6cf5ec7f

bitpos = [ 0x30, 0x32, 0x34, 0x36, 0x6f, 0x71, 0x73, 0x75, 0x29, 0x2a, 0x2c, 0x2e, 0x67, 0x68, 0x6b, 0x6d ]
N = len(bitpos)
max = 1 << N

# CMD_CHECK_PASSWORD
passbytes = open("/challenges/riscy_zones/password_is_00112233445566778899AABBCCDDEEFF.txt.encrypted", "rb").read()
#passbytes = open("/challenges/riscy_zones/secret.lzma.encrypted", "rb").read()

print("sending CMD_CHECK_PASSWORD");
foundone = False
i = 0
#for i in xrange(max):
while True:
	l = sys.stdin.readline()
	_, cand = l.split() 
	passwd = binascii.unhexlify( cand )
	
	"""
	newcand = cand
	for n in xrange(N):
		if i & (1<<n):
			newcand |= (1 << bitpos[n])
		else:
			newcand &= ~(1 << bitpos[n])
	passwd = binascii.unhexlify( "%032x" % newcand )
	"""
	#print(binascii.hexlify(passwd))
	
	msg = "\x02\x00\x00\x00"+struct.pack("<H", 16)+passwd
	msg += struct.pack("<H", 0x70) + passbytes[:0x70]
	#print(binascii.hexlify(msg))
	response = send_message( msg )
	code, = struct.unpack("<I", response[:4])
	if code == 0:
		print("Foundone: ", binascii.hexlify(passwd))
		foundone = True
	#print(code)
	#assert(code == 0)
	if (i&0xff) == 0:
		t = "*** " if foundone else ""
		print("%si=%d" % (t, i))
	i+=1
	
sys.exit(0)
outf = open(outfile, "w")

callindex = 0
off = 0x80
while off < len(fbytes):
	# CMD_DECRYPT_BLOCK
	print("sending CMD_DECRYPT_BLOCK");
	msg = "\x03\x00\x00\x00"+struct.pack("<I", callindex)+fbytes[off:off+16]
	response = send_message( msg )
	print(binascii.hexlify(msg))
	code, = struct.unpack("<I", response[:4])
	#print(code, response[8:8+16])
	print(" response: ", binascii.hexlify(response[:32]))
	assert(code == 0)
	txt = ""
	for i in range(16):
		b = ord(response[8+i]) ^ xorbytes[i]
		txt += chr(b)
	print(" txt: ", binascii.hexlify(txt))
	outf.write(txt)
	xorbytes = [ ord(c) for c in reversed(fbytes[off:off+16]) ]
	off += 16
	callindex += 1
	
outf.close()

