
import struct

OPS = {
    0x33: 'and',
}

R_type = []
I_type = []
S_type = []
U_type = []

def filter( lines, minoff, maxoff ):
    filtered = []
    for p in lines:
        lst = p.split()
        if len(lst)<3: continue
        if lst[0][-1] != ':': continue
        try:
            byteoff = int(lst[0][:-1], 16)
        except: continue
        if byteoff < minoff or byteoff > maxoff: continue
        filtered.append( p )

    return filtered
    
def translate( lines ):  
    cnt = 0
    c = ""
    for p in lines:
        lst = p.split()
        op = lst[2]
        if op in ['add', 'addi', 'and', 'andi', 'or', 'xori', 'srl', 'sll', 'srli', 'slli']:
            rd, rs, i = lst[3].split(',')
            if op == 'addi' or op == 'add': cop = '+'
            elif op == 'and' or op == 'andi': cop = '&'
            elif op == 'or' or op == 'ori': cop = '|'
            elif op == 'xor' or op == 'xori': cop = '^'
            elif op == 'srl' or op == 'srli': cop = '>>'
            elif op == 'sll' or op == 'slli': cop = '<<'
            c += "%s = %s %s %s;" % (rd, rs, cop, i)
        elif op in ['neg']:
            rd, rs = lst[3].split(',')
            if op == 'neg':     c += "%s = -%s;" % (rd, rs)
        elif op in ['sltu']:
            rd, rs, i = lst[3].split(',')
            c += '%s = %s<%s ? 1 : 0;' % (rd, rs, i)
        elif op in ['sb']:
            rd, stck = lst[3].split(',')
            print(rd, stck)
            assert(stck[-4:] == '(sp)')
            soff = int(stck[:-4], 10)
            c += "sp[ %d ] = %s;" % (soff, rd)
        elif op in ['lw']:
            pass # ignore those
        else:
            break
        c += '\n'
        cnt += 1

    print(c)
    print(p, "%s"%op, lst[3])
    pc = cnt *100 / len(filtered)
    print("%.2f%% complete" % pc)
    return c



prg = open("TA.elf.signed.disasm", "rb").readlines()
filtered = filter(prg, 0x11680, 0x118d0)
c = translate( filtered )

open("decrypt_gen_1.c", "wt").write(c)

