

insm_dis = {
    0x78: "mem[0x40+0x{0:x}] = {1}",

    0xfe: "mem[0x40+0x{0:x}] = mem[0x40+0x{1:x}]",

    0x33: '''\
mem[0x70] = 1
if mem[0x40+0x{0:x}] != {1}
    mem[0x70] = 0''',

    0x12: '''\
scr0 = {0} + ({1}<<8)
pix_y +-= scr0''',

    0xa1: '''\
if mem[0x70] != 0:
    scr0 = {0} + ({1}<<8)
    pix_y +-= scr0''',

    0xaf: 'mem[0x40+0x{0:x}] += mem[0x40+0x{1:x}]',

    0x8e: 'Not used',

    0x13: 'mem[0x40+0x{0:x}] ^= mem[0x40+0x{1:x}]',

    0xbb: '''\
tmp1 = mem[0x44] << 2
tmp2 = mem[0x20 + tmp1]
mem[0x40] = tmp2''',

    0x7c: '''\
scr0 = mem[0x00 + 0xf4b] + 2
mem[0x40] = scr0
    ''',

    0x32: '''\
push mem[0x44]
push mem[0x48]
# scramble
scr0 = (*(scr7+4) << scr7&0xff) ^ (*(scr7+4) >> scr7&0xff+1)
pop
pop
mem[0x40] = scr0
    ''',

    0x2f: '''\
scr0 = mem[0x44]
scr1 = mem[0x48]
scr0 >>= scr1
clr scr0 mask 0x3
scr0 = mem[0x00 + scr0<<2]
mem[0x40] = scr0
    ''',

    0xdc: 'sleep 3s; return',

    0x59: '''\
tmp2 = mem[0x44] << 2
mem[0x20 + tmp2] = mem[0x48]
    ''',
}


water = open("watermark.bin", "rb").read()
#print(len(water))
for i in range(0, len(water), 3):
    
    pix_y = i
    op = ord(water[i])
    arg1 = ord(water[i+1])
    arg2 = ord(water[i+2])

    if op not in insm_dis:
        print"*** 0x%x (fall through)" % op
        # this is a fall through in the interpreter table: if none of the 'if' match
        # the opcode, it falls through to the next line, which is opcode 0x78
        op = 0x78
        #continue

    fmt = insm_dis[ op ]
    #print( "0x%x"%op )
    print( ("(pix_y %3d) (OP 0x%02x):\n"%(pix_y,op)) + fmt.format(arg1, arg2) + "\n" )

    if op == 0xdc:
        print("found instruction 0xdc, stopping")
        break

